## App to find next Bus/Ferry/Train/etc

import sys,csv
from time import gmtime, strftime

current_time = str(strftime("%H%M"))
Origin_sys=sys.argv[1]
Destination_sys=sys.argv[2]


ifile  = open(r'Data.csv', "rb")
freader = csv.reader(ifile)

fields = freader.next()


dicts=[]
for Origin,Destination,Time in freader:
    dicts.append ({'Origin': Origin, 'Destination': Destination, 'Time': Time})


selected_list=[]
i=0
for each in dicts:
    if dicts[i]['Origin']==Origin_sys and dicts[i]['Destination']==Destination_sys:
        #print "All timings %(Time)s" %(dicts[i])
        selected_list.insert(0, i)
    i=i+1

if len(selected_list)==0:
    print "No buses"
    exit()

#print "Selected indexes %s" %(selected_list)

selected_list2=[]

for i in selected_list:
    #print "%s,%s" %(current_time,dicts[i]['Time'])
    if current_time < dicts[i]['Time']:
       # print "%(Time)s" %(dicts[i])
        selected_list2.insert(0, i)

if len(selected_list2)==0:
    print "No buses"
    exit()


#print "Selected indexes %s" %(selected_list2)


smallest=selected_list2[0]
#print "Smallest is %s" %(smallest)

for i in selected_list2:
    #print "%(Time)s vs " %(dicts[smallest]),
    #print "%(Time)s  " %(dicts[i])
    if dicts[smallest]['Time'] > dicts[i]['Time']:
        smallest=i
    #print "Smallest %(Time)s %(Destination)s " %(dicts[smallest])


print "Next bus is at %(Time)s hrs. " %(dicts[smallest])
ifile.close()

